<?php
/* vim: ts=4 sw=4
Plugin Name: Escriba CountDown Widget
Plugin URI: http://www.escribalabs.com/escriba-countdown-widget/
Description: This plugin shows the days e time remaining to an event/ocasion and alert the user when the time is up. Its fully custumizable and has options in the widgets admin page.
Version: 0.1
Author: C.Gurtner
Author URI: http://www.escribalabs.com/
*/ 


function widget_countdown_init() {
	if ( !function_exists('register_sidebar_widget') )
		return;

	function widget_countdown($args) {
		extract($args);

    $options = get_option('widget_countdown');
	$dateLimit = $options['dateLimit'];
	$nameEvent = $options['nameEvent'];
	$dayUnit = $options['dayUnit'];
	$backgroundColor = $options['backgroundColor'];
    $timesupmessage = $options['timesupmessage'];

echo $before_widget . $before_title . $title . $after_title;
		$url_parts = parse_url(get_bloginfo('home'));


	
	$actualdate = mktime();
	ereg("([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $dateLimit, $regs);
	$dateLimit = mktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
	$diferenceTime = $dateLimit-$actualdate;
	
	$totalday = $diferenceTime/60/60/24;
	$days = intval($totalday);
	$totalhours = ($totalday-$days)*24;
	$hours = intval($totalhours);
	$totalminuts = ($totalhours-$hours)*60;
	$minuts = intval($totalminuts);
	$totalseconds = ($totalminuts-$minuts)*60;
	$seconds = intval($totalseconds);

//************************************************************//
//Here you can modify the CSS to aply to your theme in case it is not compatible //
//************************************************************//
	echo "<style type=\"text/css\">
.clock .post_cal {
	border: 1px solid #A6A6A6;
	text-align: center;
	width: 200px;
	float: left;
	font-size: 16px;
	margin: 0 10px 5px 0;
}

	.post_cal .dayname {
		background-color: $backgroundColor;
		border-bottom: 1px solid #A6A6A6;
		color: #FFFFFF;
		font-size: 13px;
		font-weight: bolder;
		width: 100%;
	}
	
	.post_cal .daynum {
		border-bottom: 1px solid #A6A6A6;
		color: $backgroundColor;
		font-size: xx-large;
		font-weight: bold;
		width: 100%;
	}
	
	.post_cal .month, .post_cal .year {
		font-size: 12px;
		width: 100%;
		color: $backgroundColor;
	}
	</style>";



	echo "
		<div class='post_cal' id=clock_cal>
  		  <div class='dayname' id=clockday></div>
		  <div class='daynum' id=clocknum></div>
		  <div class='month' id=clockmonth><b> $nameEvent </b></div>
		</div>";
//*************//
//End of the CSS //
//**************//
	echo "
		<script language=\"JavaScript\">
			var clock_dia = '$days';
			var clock_hora = '$hours';
			var clock_minuto = '$minuts';
			var clock_segundo = '$seconds';
			
			var clockspan = document.getElementById ('clock_cal');
			var clockday = document.getElementById ('clockday');
			var clocknum = document.getElementById ('clocknum');
			var clockmonth = document.getElementById ('clockmonth');

			var clockdia_value = \"\";
			var clockhora_value = \"\";

			function mueveReloj(){
				clock_segundo -= 1;

				if (clock_segundo < 0) {
					clock_segundo = 59;
					clock_minuto -= 1;
					}

				if (clock_minuto < 0) {
					clock_minuto = 59;
					clock_hora -= 1;
					}

				if (clock_hora < 0) {
					clock_hora = 24;
					clock_dia -= 1;
					}

    		str_segundo = new String (clock_segundo)
    		if (str_segundo.length == 1)
       			clock_segundo = \"0\" + clock_segundo

    		str_minuto = new String (clock_minuto)
    		if (str_minuto.length == 1)
       			clock_minuto = \"0\" + clock_minuto

    		str_hora = new String (clock_hora)
    		if (str_hora.length == 1)
       			clock_hora = \"0\" + clock_hora

			//horaImprimible = \"Quedan \"+clock_dia+\" dias, \"+clock_hora+\" horas, \"+clock_minuto+\" minutos y \"+clock_segundo+\" segundos para el GeekTour2006\";
			diasImprimible = \"Faltam \"+clock_dia+\" $dayUnit e...\";
			horasImprimible = clock_hora+\":\"+clock_minuto+\":\"+clock_segundo;
			
if (clock_dia < 0) { 
    		   alert('$timesupmessage');
        this.removeMovieClip();
			}
			
			if (clockdia_value!=\"\"){
				clockday.removeChild(clockdia_value);
				clocknum.removeChild(clockhora_value);
				}
			clockdia_value = document.createTextNode (diasImprimible);
			clockhora_value = document.createTextNode (horasImprimible);
			clockday.appendChild(clockdia_value);
			clocknum.appendChild(clockhora_value);

    		setTimeout(\"mueveReloj()\",1000)
			}

			mueveReloj();
			
		</script>
		";

echo $after_widget;
}


function widget_countdown_control() {

		$options = get_option('widget_countdown');
		if ( !is_array($options) )
			$options = array('dateLimit'=>'2008-05-28 00:00:01','nameEvent'=>'To Priscillas Birthday', 'dayUnit'=>'Days','backgroundColor'=>'#333333','timesupmessage'=>'Happy Birthday, beloved Priscilla');
		if ( $_POST['countdown-submit'] ) {
			$options['dateLimit'] = strip_tags(stripslashes($_POST['countdown-dateLimit']));
			$options['nameEvent'] = strip_tags(stripslashes($_POST['countdown-nameEvent']));
			$options['dayUnit'] = strip_tags(stripslashes($_POST['countdown-dayUnit']));
			$options['backgroundColor'] = strip_tags(stripslashes($_POST['countdown-backgroundColor']));
		    $options['timesupmessage'] = strip_tags(stripslashes($_POST['countdown-timesupmessage']));
				

			update_option('widget_countdown', $options);
		}

		$dateLimit = htmlspecialchars($options['dateLimit'], ENT_QUOTES);
		$nameEvent = htmlspecialchars($options['nameEvent'], ENT_QUOTES);
		$dayUnit = htmlspecialchars($options['dayUnit'], ENT_QUOTES);
		$backgroundColor = htmlspecialchars($options['backgroundColor'], ENT_QUOTES);
		$timesupmessage = htmlspecialchars($options['timesupmessage'], ENT_QUOTES);

		
		echo '<p style="text-align:left;"><label for="countdown-dateLimit">Display a countdown clock. By <a href="http://www.escribalabs.com">Escriba Labs</a></label></p>';
		echo '<p style="text-align:left;"><label for="countdown-dateLimit">Day Limit: <input style="width: 100%;" id="countdown-dateLimit" name="countdown-dateLimit" type="text" value="'.$dateLimit.'" /></label><br> <small>(Format MUST be: yyyy-mm-dd hh:mm:ss)</small></p>';
		echo '<p style="text-align:left;"><label for="countdown-nameEvent">Event Name: <input style="width: 100%;" id="countdown-nameEvent" name="countdown-nameEvent" type="text" value="'.$nameEvent.'" /></label></p>';
		echo '<p style="text-align:left;"><label for="countdown-dayUnit">Day unit: <input style="width: 100%;" id="countdown-dayUnit" name="countdown-dayUnit" type="text" value="'.$dayUnit.'" /></label></p>';
		
		echo '<p style="text-align:left;"><label for="countdown-backgroundColor">Color: <input style="width: 100%;" id="countdown-backgroundColor" name="countdown-backgroundColor" type="text" value="'.$backgroundColor.'" /></label></p>';
		echo '<p style="text-align:left;"><label for="countdown-timesupmessage">Final Message: <input style="width: 100%;" id="countdown-timesupmessage" name="countdown-timesupmessage" type="text" value="'.$timesupmessage.'" /></label></p>';
		
		echo '<input type="hidden" id="countdown-submit" name="countdown-submit" value="1" />';
	}
	
	register_sidebar_widget('Escriba Countdown Widget', 'widget_countdown');
	register_widget_control('Escriba Countdown Widget', 'widget_countdown_control', 300, 350);
}
add_action('plugins_loaded', 'widget_countdown_init');


?>
